/**
 * Excerpted from the book, "Pragmatic Unit Testing in C# with NUnit, 2nd Ed."
 * ISBN 0-9776166-7-3
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/utc2 for more book information.
 */

using NUnit.Framework;
using NUnit.Framework.SyntaxHelpers;
using System;

[TestFixture]
public class LargestTest {

  [Test]
  public void Order() {
    Assert.That(Cmp.Largest(new int[] {9,8,7}), Is.EqualTo(9));
    Assert.That(Cmp.Largest(new int[] {7,9,8}), Is.EqualTo(9));
    Assert.That(Cmp.Largest(new int[] {7,8,9}), Is.EqualTo(9));
  }


  [Test]
  public void Dups() {
    Assert.That(Cmp.Largest(new int[] {9,7,9,8}), Is.EqualTo(9));
  }



  [Test]
  public void One() {
     Assert.That(Cmp.Largest(new int[] {1}), Is.EqualTo(1));
  }

  

  [Test]
  public void Negative() {
    int[] negatives = new int[] {-9, -8, -7};
    Assert.That(Cmp.Largest(negatives), Is.EqualTo(-7));
  }

}
